SystemOrganization addCategory: #ImageFootprint!

!MethodReference methodsFor: '*ImageFootprint' stamp: 'hjo 3/27/2009 10:54'!
isReal

	"Is this really a method that can be called? Unlike #DoIt."
	^self actualClass canUnderstand: self methodSymbol! !

Object subclass: #ImageFootprint
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ImageFootprint'!

!ImageFootprint classSide methodsFor: 'as yet unclassified' stamp: 'hjo 11/13/2010 09:44'!
initialize

	self new go! !

!ImageFootprint methodsFor: 'as yet unclassified' stamp: 'hjo 11/13/2010 10:15'!
dumpClasses

	self dumpClassesOn: (FileStream newFileNamed: self filepathForDumpClasses)! !

!ImageFootprint methodsFor: 'as yet unclassified' stamp: 'hjo 6/16/2011 21:19'!
dumpClassesOn: aStream

	| sortedClasses c |
	sortedClasses := Smalltalk allClasses sort: [:c1 :c2| c1 name <= c2 name].
	'Printing classes'
		displayProgressAt: Sensor cursorPoint
		from: 0 to: sortedClasses size
		during: [:bar | 1 to: sortedClasses size do: [:k| c := sortedClasses at:k.
				aStream nextPutAll: (c definition copyWithoutAll: String crlf) ; cr.
				bar value: k
				 ]
			]
! !

!ImageFootprint methodsFor: 'as yet unclassified' stamp: 'hjo 11/13/2010 10:22'!
dumpMethods

	self dumpMethodsOn: (FileStream newFileNamed: self filepathForDumpMethods)! !

!ImageFootprint methodsFor: 'as yet unclassified' stamp: 'hjo 11/13/2010 15:56'!
dumpMethodsOn: aStream

	| cm sortedMethods m vs |
	sortedMethods := ((CompiledMethod allInstances collect: [:e| e methodReference ]) reject: [:each| each isNil]) asSortedCollection.
		'Printing methods'
				displayProgressAt: Sensor cursorPoint 
		from: 0 to: sortedMethods size
 		during: [:bar| 
			1 to: sortedMethods size do: [:k|
m := sortedMethods at:k. 
vs:= m stringVersion.
			vs isNil ifTrue: [ vs:= m stringVersionDefault ].
			vs notNil ifTrue: [
				(m notNil and: [m actualClass notNil and:[m isReal]])
					ifTrue: [
						cm := m compiledMethod.
						aStream nextPutAll: vs; nextPutAll: '    ----'; nextPutAll: cm timeStamp; cr]. bar value: k]
]
			]

! !

!ImageFootprint methodsFor: 'as yet unclassified' stamp: 'hjo 3/27/2009 10:58'!
fileStem

	^FileDirectory baseNameFor: (FileDirectory localNameFor: SmalltalkImage current imageName)! !

!ImageFootprint methodsFor: 'as yet unclassified' stamp: 'hjo 4/1/2009 00:01'!
filepathForDumpClasses

	^self fileStem , '.classDump'! !

!ImageFootprint methodsFor: 'as yet unclassified' stamp: 'hjo 4/1/2009 00:02'!
filepathForDumpMethods

	^self fileStem , '.methodDump'! !

!ImageFootprint methodsFor: 'as yet unclassified' stamp: 'hjo 11/13/2010 10:24'!
filepathForImageFootprint

	^self fileStem , '.imageFootprint'! !

!ImageFootprint methodsFor: 'as yet unclassified' stamp: 'hjo 4/1/2009 00:07'!
fullFilepathForDumpClasses

	^FileDirectory fullPathForURI: self filepathForDumpClasses! !

!ImageFootprint methodsFor: 'as yet unclassified' stamp: 'hjo 4/1/2009 00:07'!
fullFilepathForDumpMethods

	^FileDirectory fullPathForURI: self filepathForDumpMethods! !

!ImageFootprint methodsFor: 'as yet unclassified' stamp: 'hjo 11/13/2010 10:24'!
fullFilepathForImageFootprint

	^FileDirectory fullPathForURI: self filepathForImageFootprint! !

!ImageFootprint methodsFor: 'as yet unclassified' stamp: 'hjo 4/1/2009 00:08'!
fullFilepaths

	^Array with: self fullFilepathForDumpClasses with: self fullFilepathForDumpMethods! !

!ImageFootprint methodsFor: 'as yet unclassified' stamp: 'hjo 6/16/2011 21:47'!
go

	|stream|
	stream := FileStream newFileNamed: self filepathForImageFootprint.
	self dumpClassesOn: stream.
	self dumpMethodsOn: stream.
	stream close.
	SoundService default soundEnabled: true.
	SoundService default new beep
! !
ImageFootprint initialize!
